#ifndef __I3_H__
#define __I3_H__

typedef
struct _i3_t {
	int		 i3_type;
	int		 i3_ttl;
	char	*o_mname;
	char	*o_uname;
	char	*t_mname;
	char	*t_uname;
	void	*data;
} i3_t;

#if 0
char *i3_types[] =
{
	"tell",
	"emoteto",
	"who-req",
	"who-reply",
	"finger-req",
	"finger-reply",
	"locate-req",
	"locate-reply",
	"chanlist-reply",
	"channel-m",
	"channel-e",
	"channel-t",
	"channel-add",
	"channel-remove",
	"channel-admin",
	"chan-filter-req",
	"chan-filter-reply",
	"chan-who-req",
	"chan-who-reply",
	"channel-listen",
	"chan-user-req",
	"chan-user-reply",
	"news-read-req",
	"news-post-req",
	"news-grplist-req ",
	"mail",
	"mail-ack",
	"file-list-req",
	"file-list-reply",
	"file-put",
	"file-put-ack",
	"file-get-req",
	"file-get-reply",
	"auth-mud-req",
	"auth-mud-reply",
	"ucache-update",
	"error",
	"startup-req-3",
	"startup-reply",
	"shutdown",
	"mudlist",
	"oob-req",
	"oob-begin",
	"oob-end",
	NULL
};
#endif

typedef
struct _typedata {
	char	*i3_desc;
	char	*i3_fmt;
} typedata;

typedata i3_typedata[] =
{
	{ "tell",				"ss"	},
	{ "emoteto",			"ss"	},
	{ "who-req",			""		},
	{ "who-reply",			"a"		},
	{ "finger-req",			"s"		},
	{ "finger-reply",		"sssssvsss" },
	{ "locate-req",			"s"		},
	{ "locate-reply",		"ssvs"	},
	{ "chanlist-reply",		"vm"	},
	{ "channel-m",			"sss"	},
	{ "channel-e",			"sss"	},
	{ "channel-t",			"sssssss" },
	{ "channel-add",		"ss"	},
	{ "channel-remove",		"s"		},
	{ "channel-admin",		"saa"	},
	{ "chan-filter-req",	"sa"	},
	{ "chan-filter-reply",	"sa"	},
	{ "chan-who-req",		"s"		},
	{ "chan-who-reply",		"sa"	},
	{ "channel-listen",		"sv"	},
	{ "chan-user-req",		"s"		},
	{ "chan-user-reply",	"ssv"	},
	{ "news-read-req",		"sv"	},
	{ "news-post-req",		"xssvsssss" },
	{ "news-grplist-req ",	"xs"	},
	{ "mail",				"xsvsmmavss" },
	{ "mail-ack",			"xsm"	},
	{ "file-list-req",		"x"		},
	{ "file-list-reply",	"x"		},
	{ "file-put",			"x"		},
	{ "file-put-ack",		"x"		},
	{ "file-get-req",		"x"		},
	{ "file-get-reply",		"x"		},
	{ "auth-mud-req",		""		},
	{ "auth-mud-reply",		"v"		},
	{ "ucache-update",		"ssv"	},
	{ "error",				"ssa"	},
	{ "startup-req-3",		"vvvvvvssssssmm" },
	{ "startup-reply",		"av"	},
	{ "shutdown",			"v"		},
	{ "mudlist",			"vm"	},
	{ "oob-req",			""		},
	{ "oob-begin",			"xssvv"	},
	{ "oob-end",			"xss"	},
	{ NULL,					NULL	}
};

#endif
