#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include "packet.h"
#include "config.h"
#include "value.h"
#include "lists.h"
#include "i3.h"

long	 i3_ntypes;

void packet_init (void)
	{ i3_ntypes = sizeof(i3_typedata) / sizeof(i3_typedata[0]); }

char * packet_int_to_desc (int p_type)
	{ return ((p_type<i3_ntypes)?i3_typedata[p_type].i3_desc:NULL); }
int
packet_desc_to_int (char *p_desc)
{
	int		  i = 0;
	while (i3_typedata[i].i3_desc &&
			strcmp(i3_typedata[i].i3_desc, p_desc)) i++;
	return (i3_typedata[i].i3_desc?i:-1);
}

listentry *
packet_node_new (int v_type, void *v_data)
{
	listentry	*l;
	value		*v;
	v = value_new(v_type);
	switch(v_type) {
		case MM_STRING:
			v->v_string = (v_data?strdup((char *)(v_data)):NULL);
			v->v_value = (v_data?strlen((char *)(v_data)):0);
			break;
		case MM_VALUE:
			v->v_value = (long)(v_data);
			break;
		case MM_ARRAY:
			v->v_array = v_data;
			break;
		case MM_MAPPING:
			v->v_mapping = v_data;
		default:
			fprintf(stderr, "packet_node_new called with %d\n", v_type);
	}
	l = list_item_new();
	l->data = (void *)(v);
	return l;
}

#define ST_NAMES char *s_uname, char *t_mname, char *t_uname
#define L_NSTR(r, s) list_append(r, packet_node_new(MM_STRING, s))
#define L_NVAL(r, v) list_append(r, packet_node_new(MM_VALUE, (void*)v))
#define L_NARR(r, d) list_append(r, packet_node_new(MM_ARRAY, d))
#define L_NMAP(r, d) list_append(r, packet_node_new(MM_MAPPING, d))

void
packet_head_create (listentry *root, char *p_desc, ST_NAMES)
{
	if (packet_desc_to_int(p_desc) == -1) return;

	L_NSTR(root, p_desc);
	L_NVAL(root, 5);
	L_NSTR(root, CONFIG_MUDNAME);
	L_NSTR(root, s_uname);
	L_NSTR(root, t_mname);
	L_NSTR(root, t_uname);
}

/* DON'T FUCK THIS UP */
void
packet_generic_create (listentry *root, int p_type, 
		char *s_uname, char *t_mname, char *t_uname, ... )
{
	va_list	 ap;
	char	*p_desc;
	char	*p_fmt;

	p_desc = i3_typedata[p_type].i3_desc;
	p_fmt = i3_typedata[p_type].i3_fmt;

	va_start(ap, t_uname);
	
	if (*p_fmt != 'x')
	packet_head_create(root, "locate-reply", s_uname, t_mname, t_uname);

	while (*p_fmt) {
		switch(*p_fmt++) {
			case 's':
				L_NSTR(root, va_arg(ap, char *));
				break;
			case 'v':
				L_NVAL(root, va_arg(ap, long));
				break;
			case 'a':
				L_NARR(root, va_arg(ap, void *));
				break;
			default:
				fprintf(stderr, "Error in format string.");
		}
	}
	va_end(ap);
}
