#include <stdio.h>
#include "value.h"
#include "lists.h"
#include "tree.h"

void tree_print_array (listentry *list);
void tree_print_mapping (listentry *list);

void
tree_print_value (listentry *node)
{
	switch(NODEVALUE(node)->v_type) {
		case MM_ARRAY:
			printf(" ({");
			tree_print_array((listentry *)(NODEVALUE(node)->v_array));
			printf(" })");
			break;
		case MM_MAPPING:
			printf(" ([");
			tree_print_mapping((listentry *)(NODEVALUE(node)->v_mapping));
			printf(" ])");
			break;
		case MM_STRING:
			if (NODEVALUE(node)->v_string)
				printf(" %s", NODEVALUE(node)->v_string);
			else
				printf(" 0");
			break;
		case MM_VALUE:
			printf(" %ld", NODEVALUE(node)->v_value);
			break;
		case MM_NONE:
			printf(" [NULL]");
			break;
	}
}

void
tree_print (listentry *node)
{
	tree_print_value(node);
	printf("\n");
}

void
tree_print_array (listentry *list)
{
	listentry	*node;
	int			 cpr = 0;

	node = list->next;
	while (node != list) {
		if (cpr) printf(",");
		cpr = 1;
		tree_print_value(node);
		node = node->next;
	}
}

void
tree_print_mapping (listentry *list)
{
	listentry	*node;
	int			 cpr = 0;

	node = list->next;
	while (node != list) {
		if (cpr) printf(",");
		cpr = 1;
		tree_print_value(node);
		node = node->next;
	}
}
